#!/bin/sh
# wdimex.sh -- make the message file for MFI
#
# History:  97/01/23 kmflynn
#
# Usage: wdimex.sh [> wdimex.out]

# pathname
WrdA=/usr/opt/wrdapp

#*******************************************************************
#***** You should not need to modify anything below this line. *****
#*******************************************************************

# pathnames and file names
  Libr=$WrdA/lib3.1
  Name=mfi
  Seqs='mfi'

  echo
  echo ' Library = ' $Libr
  echo ' wdm name = ' $Name.wdm
  echo ' sequentials =' $Seqs
  echo

# remove any old files
  if [ -f $Name.wdm ] ; then rm $Name.wdm ; fi
  if [ -f error.fil ] ; then rm error.fil ; fi
  if [ -f wdimex.in ] ; then rm wdimex.in ; fi

# build input file
  echo $Name.wdm > wdimex.in
  for Seq in $Seqs ; do
     echo I >> wdimex.in
     echo $Seq.seq >> wdimex.in
  done
  echo R >> wdimex.in

#
# get message file shell
  cp $Libr/lib_data/message.wdm $Name.wdm

# build message file
  $Libr/bin/wdimex < wdimex.in

# remove old message file and move new one into bin
  if [ -f ../bin_data/$Name.wdm ] ; then rm ../bin_data/$Name.wdm ; fi
  mv $Name.wdm ../bin_data

# end of shell
