      SUBROUTINE STRAL(IBDSAM,INMP,NSS,NTRIB,NDIV,ICALC)
C
C     ******************************************************************
C     ALLOCATE ARRAY STORAGE FOR STREAMS
C     ******************************************************************
C
C     SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
C  Common block for STR Package
      COMMON /STRCOM/STRAUX(3)
      CHARACTER*16 STRAUX
      CHARACTER*150 LINE
C     ------------------------------------------------------------------
      IN=IUNIT(18)
C
C1------IDENTIFY PACKAGE AND INITIALIZE NSTREM.
      WRITE(IOUT,1)IN
    1 FORMAT(1X,/1X,'STR -- STREAM PACKAGE,',
     1       ' INPUT READ FROM UNIT',I3)
C
C2------READ FIRST RECORD
      READ(IUREAL(IN),'(A)') LINE
      READ(LINE,'(5I10,F10.0,2I10)')
     1       MXSTRM,NSS,NTRIB,NDIV,ICALC,CONST,ISTRCB,ISTCB2
      LLOC=81
      IF(CONST.LT.0.) CONST=0.
      CALL VALSAV('CONST',0,0,CONST)
      IF(MXSTRM.LT.0)MXSTRM=0
      IF(NTRIB.LT.0) NTRIB=0
      WRITE(IOUT,4)MXSTRM,NSS,NTRIB
    4 FORMAT(1H ,'MAXIMUM OF',I5,' STREAM NODES'//1X,'NUMBER OF STREAM S
     1EGMENTS IS ',I5//1X,'NUMBER OF STREAM TRIBUTARIES IS ',I5//)
      IF(NTRIB.GT.10) THEN
         WRITE(IOUT,*) ' NTRIB CANNOT BE GREATER THAN 10'
         CALL RDABRT
      END IF
      IF(NSS.LE.0) THEN
         WRITE(IOUT,*) ' NSS MUST BE GREATER THAN 0'
         CALL RDABRT
      END IF
      IF(NDIV.GT.0) WRITE(IOUT,5)
    5 FORMAT(1X,'DIVERSIONS FROM STREAMS HAVE BEEN SPECIFIED')
      IF(ICALC.GT.0) WRITE(IOUT,6) CONST
    6 FORMAT(1X,'STREAM STAGES WILL BE CALCULATED USING A CONSTANT OF
     1',1P,G15.4)
      IF(ISTRCB.LT.0) WRITE(IOUT,7)
    7 FORMAT(1X,'CELL-BY-CELL FLOWS WILL BE PRINTED WHEN ICBCFL NOT 0')
      IF(ISTRCB.GT.0) WRITE(IOUT,8) ISTRCB
    8 FORMAT(1X,'CELL-BY-CELL FLOWS WILL BE SAVED ON UNIT',I3)
      IF(ISTRCB.LT.0) ISTRCB=-1
      IUNIT2(18)=ISTRCB
      IF(ISTRCB.GT.0) THEN
         IF(FILTYP(ISTRCB).EQ.'DATA(BINARY)') THEN
            IFNUSE(ISTRCB)=IUNIT(12)
         ELSE IF(FILTYP(ISTRCB).EQ.' ') THEN
            IUNIT2(18)=0
         ELSE
            WRITE(IOUT,*)
     1 'Attempt to save CBC budget in a file that is not DATA(BINARY)'
            CALL RDABRT
         END IF
         IF((IHEDUN.GT.0 .AND. IUNIT2(18).EQ.IHEDUN) .OR.
     1      (IDDNUN.GT.0 .AND. IUNIT2(18).EQ.IDDNUN)) THEN
            WRITE(IOUT,*) 'CBC file is same as HEAD or DRAWDOWN file'
            CALL RDABRT
         END IF
      END IF
      IF(IBDSAM.EQ.-2) THEN
         IF(ISTRCB.NE.0) IBDSAM=ISTRCB
      ELSE
         IF(IBDSAM.NE.ISTRCB) IBDSAM=0
      END IF
C
C  Make sure ISTCB2 is a valid unit if non zero
      WRITE(IOUT,*) ' ISTCB2:',ISTCB2
      IF(ISTCB2.LE.0) THEN
         ISTCB2=0
      ELSE
         IF(FILTYP(ISTCB2).EQ.'DATA(BINARY)') THEN
            IF(IFNUSE(ISTCB2).EQ.-1) THEN
               IFNUSE(ISTCB2)=IUNIT(18)
            ELSE
               WRITE(IOUT,*)
     1            ' File unit is being used by another package'
               CALL RDABRT
            END IF
         ELSE IF(FILTYP(ISTCB2).EQ.' ') THEN
            ISTCB2=0
         ELSE
            WRITE(IOUT,*)
     1 ' ISTCB2 specifies a file that is not DATA(BINARY)'
            CALL RDABRT
         END IF
      END IF
      CALL IVLSAV('ISTCB2',0,0,ISTCB2)
C
C-------Process auxiliary parameters
      STRAUX(1)=' '
      NAUX=0
20    CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,IN)
      IF(LINE(ISTART:ISTOP).EQ.'AUXILIARY' .OR.
     1   LINE(ISTART:ISTOP).EQ.'AUX') THEN
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,IN)
         IF(NAUX.EQ.0) THEN
            NAUX=1
            IF(LINE(ISTART:ISTOP).EQ.'IFACE') THEN
               STRAUX(1)='IFACE'
               WRITE(IOUT,22) STRAUX(1)
            ELSE
               IF(INMP.EQ.0) THEN
                  NAUX=2
                  STRAUX(NAUX)=LINE(ISTART:ISTOP)
                  WRITE(IOUT,22) STRAUX(NAUX)
               ELSE
                  WRITE(IOUT,22) LINE(ISTART:ISTOP)
                  WRITE(IOUT,*) 'When MODPATH is used, the 1st',
     1                   ' AUXILIARY parameter must be "IFACE"'
                  CALL RDABRT
               END IF
            END IF
         ELSE IF(NAUX.LT.3) THEN
            NAUX=NAUX+1
            STRAUX(NAUX)=LINE(ISTART:ISTOP)
            WRITE(IOUT,22) STRAUX(NAUX)
22          FORMAT(1X,'AUXILIARY STREAM PARAMETER: ',A)
         ELSE
            WRITE(IOUT,*) ' Too many auxiliary parameters for MFI'
            CALL RDABRT
         END IF
         GO TO 20
      ELSE IF(LINE(ISTART:ISTOP).EQ.'CBCALLOCATE') THEN
         GO TO 20
      END IF
C  Allow use of MODPATH without an explicit IFACE auxiliary parameter -- turn
C  the IFACE parameter on if MODPATH is active.
      IF(INMP.NE.0) STRAUX(1)='IFACE'
C
C6------RETURN.
      RETURN
      END
      SUBROUTINE STRRP(KPER,IWARN,NSS,NTRIB,NDIV,ICALC)
C
C     ******************************************************************
C     READ STREAM PARAMETERS EACH STRESS PERIOD
C     ******************************************************************
C
C     SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
C  Common block for STR Package
      COMMON /STRCOM/STRAUX(3)
      CHARACTER*16 STRAUX
      CHARACTER*10 CMAX
C     ------------------------------------------------------------------
      IN=IUNIT(18)
C
C1------READ ITMP (NUMBER OF STREAM REACHES OR FLAG TO REUSE DATA).
      READ(IUREAL(IN),'(3I10)') ITMP,IRDFLG,IPTFLG
      CALL IVLSAV('IRDFLG',0,KPER,IRDFLG)
      CALL IVLSAV('IPTFLG',0,KPER,IPTFLG)
      IF(ITMP.EQ.IMISS) THEN
         WRITE(IOUT,*) ' Undefined STREAM data for stress period'
         RETURN
      END IF
      CALL LSTMAK('STREAM',0,KPER,17)
      ARRCON(NARRAY)=1.
      IARRDA(1,NARRAY)=-2
C
C2------TEST ITMP.
      IF(ITMP.GE.0)GO TO 50
C
C2A-----IF ITMP <0 THEN REUSE DATA FROM LAST STRESS PERIOD.
      WRITE(IOUT,7)
    7 FORMAT(1X,/1X,'REUSING STREAM REACHES FROM LAST STRESS PERIOD')
      IF(KPER.EQ.1) THEN
         WRITE(IOUT,*) ' ATTEMPT TO REUSE UNDEFINED STREAM DATA'
         CALL RDABRT
      END IF
      NSTREM=-1
      CALL IVLSAV('STREAM',0,KPER,NSTREM)
      RETURN
C
C3------IF ITMP=> ZERO THEN IT IS THE NUMBER OF STREAM REACHES.
   50 NSTREM=ITMP
      IF(ITMP.GT.MXLIST*10) THEN
         ITMP=MXLIST*10
         WRITE(CMAX,'(I10)') ITMP
         WRITE(IOUT,'(A)')
     1' WARNING -- Truncating STREAM reaches -- maximum number is'//CMAX
         IWARN=IWARN+1
         IF(NMISS.LT.45) THEN
            NMISS=NMISS+1
            CTEXT(NMISS)=
     1' WARNING -- Truncating STREAM reaches -- maximum number is'//CMAX
         END IF
      END IF
      CALL IVLSAV('STREAM',0,KPER,ITMP)
C
C5------PRINT NUMBER OF STREAM REACHES IN THIS STRESS PERIOD.
  100 WRITE(IOUT,101)NSTREM
  101 FORMAT(1X,//1X,I5,' STREAM REACHES')
C
C6------IF THERE ARE NO STREAM REACHES THEN RETURN.
      IF(NSTREM.EQ.0) RETURN
C
C7------READ AND PRINT DATA FOR EACH STREAM REACH.
      CALL STRLRD(NSTREM,NARRAY,X(IARRDA(2,NARRAY)),IN,STRAUX,3,
     1     NSS,NTRIB,NDIV,ICALC,KPER)
C
C-------RETURN.
      RETURN
      END
      SUBROUTINE STRLRD(NSTREM,NAR,IXLOC,IN,CAUX,NCAUX,
     1        NSS,NTRIB,NDIV,ICALC,KPER)
C     ******************************************************************
C     Read and print a list of stream data.  NCAUX of the values in the
C     list are optional -- auxiliary data.
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      DIMENSION IXLOC(10)
      DIMENSION VAL(3)
      DIMENSION ITRIB(10)
      CHARACTER*16 CAUX(NCAUX)
      CHARACTER*120 LINE
      CHARACTER*120 BUF
      CHARACTER*16 CTMP
      CHARACTER*1 DASH(120)
      DATA DASH/120*'-'/
C
      NGROUP=(NSTREM-1)/MXLIST + 1
      CALL LSTAL2(NAR,NGROUP)
      LSTDIM=IARRDA(3,NAR)
C
C  Make sure 1st auxiliary parameter is 0 when IFACE is not a parameter
      VAL(1)=0.
      NAUX=0
      BUF=' '
      NBUF=4
      DO 10 I=1,NCAUX
      IF(CAUX(I).NE.' ') THEN
         N1=NBUF+1
         NBUF=NBUF+16
         BUF(N1:NBUF)=CAUX(I)
         NAUX=NAUX+1
      END IF
10    CONTINUE
      WRITE(IOUT,4) BUF(1:NBUF)
    4 FORMAT('    LAYER   ROW    COL    SEGMENT   REACH   STREAMFLOW',
     1'      STREAM    STREAMBED     STREAMBED BOT  STREAMBED TOP',/,
     2       '                           NUMBER   NUMBER            ',
     3'       STAGE   CONDUCTANCE      ELEVATION      ELEVATION',A)
      WRITE(IOUT,'(3X,110(''-''),50A1)') (DASH(J),J=1,NBUF)
C
      DO 250 II=1,NSTREM
      IGROUP=(II-1)/MXLIST + 1
      LOC=IXLOC(IGROUP) + (II-1-(IGROUP-1)*MXLIST)*LSTDIM - 1
C  Read a line into a buffer
      READ(IUREAL(IN),'(A)') LINE
C  Start by reading all the standard parameters
      READ(LINE,204) K,I,J,IS,IR,FLOW,STAGE,COND,SBOT,STOP
204   FORMAT(5I5,F15.0,4F10.0)
      LLOC=81
C
C  Read any optional parameters
      NBUF=1
      DO 225 KK=1,NCAUX
      IF(CAUX(KK).NE.' ') THEN
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,N,AUX,-1,IN)
         VAL(KK)=AUX
         WRITE(CTMP,'(G16.4)') AUX
         N1=NBUF+1
         NBUF=NBUF+16
         BUF(N1:NBUF)=CTMP
      END IF
225   CONTINUE
C  Write the values that were read
      WRITE(IOUT,226) K,I,J,IS,IR,FLOW,STAGE,COND,SBOT,STOP,BUF(1:NBUF)
226   FORMAT(1X,3X,I4,2I7,2I9,7X,G11.4,G12.4,G11.4,4X,2G13.4,A)
C
C  Check for illegal grid location
      IF(K.LT.1 .OR. K.GT.NLAY) THEN
         WRITE(IOUT,*) ' Layer number is outside of the grid'
         CALL RDABRT
      END IF
      IF(I.LT.1 .OR. I.GT.NROW) THEN
         WRITE(IOUT,*) ' Row number is outside of the grid'
         CALL RDABRT
      END IF
      IF(J.LT.1 .OR. J.GT.NCOL) THEN
         WRITE(IOUT,*) ' Column number is outside of the grid'
         CALL RDABRT
      END IF
C
C  Move the values into storage
      IF(II.GT.MXLIST*10) GO TO 250
      X(LOC+1)=K
      X(LOC+2)=I
      X(LOC+3)=J
      X(LOC+4)=STAGE
      X(LOC+5)=COND
      X(LOC+6)=SBOT
      X(LOC+7)=IS
      X(LOC+8)=FLOW
      X(LOC+11)=STOP
      IF(NCAUX.GT.0) THEN
         DO 240 KK=1,NCAUX
         X(LOC+14+KK)=VAL(KK)
  240    CONTINUE
      END IF
  250 CONTINUE
      CAUX(1)='IFACE'
C
C  Check stream data for correct ordering of segments
      CALL SEGORD(KPER,IERR)
      IF(IERR.NE.0) THEN
         WRITE(IOUT,*) ' Aborting because of segment numbering problem'
         WRITE(IOUT,*) ' Stream reaches must be in order by segments'
         WRITE(IOUT,*) ' Segments must be consecutive starting with 1'
         CALL RDABRT
      END IF
C
C  Read data for calculating stream stage
      IF(ICALC.GT.0) THEN
         WRITE(IOUT,297)
297      FORMAT(1H0,3X,'LAYER',3X,'ROW',4X,'COL   ',' SEGMENT',3X,
     1   'REACH',8X,'STREAM',13X,'STREAM',10X,'ROUGH',/27X,'NUMBER',3X,
     2   'NUMBER',8X,'WIDTH',14X,'SLOPE',10X,'COEF.',/3X,110('-'))
         ISOLD=0
         DO 300 II=1,NSTREM
         IGROUP=(II-1)/MXLIST + 1
         LOC=IXLOC(IGROUP) + (II-1-(IGROUP-1)*MXLIST)*LSTDIM - 1
         READ(IN,298) WIDTH,SLOPE,ROUGH
298      FORMAT(3F10.0)
         K=X(LOC+1)
         I=X(LOC+2)
         J=X(LOC+3)
         IS=X(LOC+7)
         IF(IS.NE.ISOLD) THEN
            ISOLD=IS
            N=0
         END IF
         N=N+1
         WRITE(IOUT,299) K,I,J,IS,N,WIDTH,SLOPE,ROUGH
299      FORMAT(4X,I4,2I7,2I9,7X,G12.4,4X,G13.4,4X,G12.4)
         X(LOC+12)=WIDTH
         X(LOC+13)=SLOPE
         X(LOC+14)=ROUGH
300      CONTINUE
      END IF
C
C  Read tributary data
      IF(NTRIB.GT.0) THEN
         WRITE(IOUT,361)
361      FORMAT('0',20X,'STREAM SEGMENT',15X,
     1            'TRIBUTARY STREAM SEGMENT NUMBERS')
         DO 400 KK=1,NSS
         READ(IN,'(10I5)') (ITRIB(II),II=1,NTRIB)
         WRITE(IOUT,362) KK,(ITRIB(II),II=1,NTRIB)
362      FORMAT(20X,I5,20X,10I5)
         DO 390 II=1,NTRIB
         IF(ITRIB(II).LT.1) GO TO 390
            DO 370 JJ=1,NSTREM
            IGROUP=(JJ-1)/MXLIST + 1
            LOC=IXLOC(IGROUP) + (JJ-1-(IGROUP-1)*MXLIST)*LSTDIM - 1
            IS=X(LOC+7)
            IF(IS.EQ.ITRIB(II)) THEN
               X(LOC+9)=KK
               GO TO 390
            END IF
370         CONTINUE
390      CONTINUE
400      CONTINUE
      END IF
C
C  Read diversions
      IF(NDIV.GT.0) THEN
      WRITE(IOUT,413)
413   FORMAT('0',10X,'DIVERSION SEGMENT NUMBER',10X,
     1       'UPSTREAM SEGMENT NUMBER')
      DO 500 JJ=1,NSS
      READ(IN,'(I10)') IDIV
      WRITE(IOUT,415) JJ,IDIV
415   FORMAT(20X,I5,28X,I5)
      DO 480 II=1,NSTREM
      IGROUP=(II-1)/MXLIST + 1
      LOC=IXLOC(IGROUP) + (II-1-(IGROUP-1)*MXLIST)*LSTDIM - 1
      IS=X(LOC+7)
      IF(IS.EQ.JJ) THEN
         X(LOC+10)=IDIV
         GO TO 500
      END IF
480   CONTINUE
500   CONTINUE
      END IF
C
      RETURN
      END
      SUBROUTINE SEGORD(KPER,IERR)
C     ******************************************************************
C  Check stream data for correct order of segments
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      DIMENSION IX(LENX)
      EQUIVALENCE (X,IX)
C     ------------------------------------------------------------------
      IERR=0
      CALL IVLGET('STREAM',0,KPER,NAR,NSTREM)
      LSTDIM=IARRDA(3,NAR)
      IXBEG=IARRDA(2,NAR)
      IF(NSTREM.LE.0) RETURN
C
C  First segment must be 1
      LOC=IX(IXBEG)-1
      IS=X(LOC+7)
      IF(IS.NE.1) THEN
         IERR=1
         RETURN
      END IF
C
C  Segments must be in order from 1 to N
      ISOLD=0
      DO 300 II=1,NSTREM
      IGROUP=(II-1)/MXLIST + 1
      LOC=IX(IXBEG+IGROUP-1) + (II-1-(IGROUP-1)*MXLIST)*LSTDIM - 1
      IS=X(LOC+7)
      IF(IS.NE.ISOLD) THEN
         ISOLD=ISOLD+1
         IF(IS.NE.ISOLD) THEN
            IERR=1
            RETURN
         END IF
      ELSE
C  Force parameters associated with a segment rather than a branch to
C  be 0 for all branches in a segment except the first branch.
         X(LOC+8)=0.
         X(LOC+9)=0.
         X(LOC+10)=0.
      END IF
300   CONTINUE

      RETURN
      END
      SUBROUTINE STRED
C     ******************************************************************
C     Edit STREAM data
C     ******************************************************************
      INCLUDE 'mfi.gbl'
C  Common block for STR Package
      COMMON /STRCOM/STRAUX(3)
      CHARACTER*16 STRAUX
      CHARACTER*8 LABEL(14,2)
      DATA LABEL/
     1 ' ',    ' ',  ' ',     ' ',    ' ',   ' ',   ' ',
     2 ' ',   'Downstr.',' ',     ' ',   ' ',    ' ',    ' ',
     3 'Layer','Row','Column','Stage','Cond','Sbot','Seg',
     4 'Flow','Segment', 'Iupseg','Stop','Width','Slope','Rough'/
C
C  Set IUNIT if not already set
      IF(IUNIT(18).EQ.0) THEN
         CALL FINDUN(28,IU,'STR')
         IUNIT(18)=IU
         IUNIT2(18)=0
      END IF
C
C  Main STR menu
      IOPT=1
5     CALL QRESP(MESSFL,307,6,IOPT)
C
      IF(IOPT.EQ.1) THEN
C  Define CONST and ISTCB2
         CALL STRCON
      ELSE IF(IOPT.EQ.2) THEN
C  Display a help screen that explains the fields entered in the spreadsheet
         CALL PMXCNW(MESSFL,307,8,50,1,0,LINCNT)
      ELSE IF(IOPT.EQ.3) THEN
C  Stress period data -- select the desired stress period -- default is 1
         KPER=1
10       CALL UPERIN('STREAM Data',KPER)
C  Return if "previous" was selected
         IF(KPER.EQ.0) THEN
            CALL STRSV(IUNDEF,1)
            RETURN
         END IF
C
C  Set up to get STREAM data for a stress period.
C  If array does not already exist, create array.
         CALL IVLGET('STREAM',0,KPER,NAR,NSTREM)
         IF(NAR.LE.0) THEN
            CALL LSTMAK('STREAM',0,KPER,17)
            IARRDA(1,NARRAY)=-2
            ARRCON(NARRAY)=1.
            NSTREM=0
            NAR=NARRAY
         END IF
C
C  Get new data -- IMETH is the choice for editing data (1) or reusing
C  previous data (2)
15       IMETH=1
         IF(KPER.GT.1) THEN
            IF(NSTREM.LT.0) IMETH=2
            CALL QRESP(MESSFL,307,4,IMETH)
         END IF
         IF(IMETH.EQ.1) THEN
            LOC=IARRDA(2,NAR)
            CALL SSLST(X(LOC),NSTREM,LABEL,14,NAR,STRAUX,3)
            CALL SEGORD(KPER,IERR)
            IF(IERR.NE.0) THEN
               IRESP=1
               CALL QRESP(MESSFL,307,5,IRESP)
               IF(IRESP.EQ.1) GO TO 15
               NSTREM=0
            END IF
         ELSE
            NSTREM=-1
         END IF
         CALL IVLSAV('STREAM',0,KPER,NSTREM)
C
C  Ask for another stress period
         KPER=KPER+1
         IF(KPER.GT.NPER) KPER=1
         IF(NPER.GT.1) GO TO 10
C
      ELSE
C  End of STREAM data input
         CALL STRSV(IUNDEF,1)
         RETURN
      END IF
C
C  Completed one pass through the STR main menu -- go back through it
      IOPT=IOPT+1
      IF(IOPT.GT.4) IOPT=1
      GO TO 5
C
      END
      SUBROUTINE STRSV(IUNDEF,IWRFLG)
C     ******************************************************************
C     SAVE DATA FOR STREAM PACKAGE
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
C  Common block for STR Package
      COMMON /STRCOM/STRAUX(3)
      CHARACTER*16 STRAUX
C     ------------------------------------------------------------------
      IF(IUNIT(18).EQ.0) THEN
         IUNDEF=-1
         RETURN
      END IF
C
      DO 5 I=1,MXFNAM
      IF(IFNUSE(I).EQ.IUNIT(18)) IFNUSE(I)=0
5     CONTINUE
      IFNUSE(IUNIT(18))=IUNIT(18)
      CALL IVLGET('ISTCB2',0,0,ITYPE,ISTCB2)
      IF(ITYPE.NE.0) ISTCB2=0
      IF(ISTCB2.GT.0) IFNUSE(ISTCB2)=IUNIT(18)
C
      IF(IUREAL(IUNIT(18)).EQ.0) CALL REALUN(IUNIT(18))
      IUNDEF=0
      IFIL=IUMISC
      IF(IWRFLG.LE.0) IFIL=0
      IF(IWRFLG.EQ.1) OPEN(FILE='MFI.STR',UNIT=IFIL)
      IF(IWRFLG.GT.1) OPEN(FILE=FILNAM(IUNIT(18)),UNIT=IFIL)
C
C  Find undefined data and maximum number of STREAMs in all periods
      CALL LSTMAX('STREAM',IWRFLG,IUNDEF,MXSTRM,'STR')
      IF(IWRFLG.LE.0) RETURN
C  Find NSS,NTRIB,NDIV
      CALL STRMAX(NSS,NTRIB,NDIV,ICALC)
C
C  Write the data
      ISTRCB=IBUDUN
      IF(IBUDUN.EQ.0) ISTRCB=IUNIT2(18)
      ITMPUN=ISTRCB
      IF(ITMPUN.GT.0) THEN
         IF(IUREAL(ITMPUN).EQ.0) CALL REALUN(ITMPUN)
         ITMPUN=IUREAL(ITMPUN)
      END IF
      ITMPU2=ISTCB2
      IF(ITMPU2.GT.0) THEN
         IF(IUREAL(ITMPU2).EQ.0) CALL REALUN(ITMPU2)
         ITMPU2=IUREAL(ITMPU2)
      END IF
C
C  Write data for each stress period
      CALL STRSAV(IFIL,MXSTRM,ITMPUN,ITMPU2,STRAUX,3,NSS,NTRIB,
     1            NDIV,ICALC)
C
      CLOSE(UNIT=IFIL)
      CALL FNMRMV
      RETURN
      END
      SUBROUTINE STRSAV(IFIL,MXSTRM,ITMPUN,ITMPU2,CAUX,NCAUX,NSS,NTRIB,
     1            NDIV,ICALC)
C     ******************************************************************
C     Write STR data for all stress periods with auxiliary data values.
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      CHARACTER*16 CAUX(NCAUX)
      DIMENSION IX(LENX)
      EQUIVALENCE (X,IX)
      CHARACTER*10 FIELD
      CHARACTER*120 RECORD
      CHARACTER*70 AUX
      DIMENSION ITRIB(10)
C     ------------------------------------------------------------------
      IF(NTRIB.GT.10) NTRIB=10
C
C  Write first record
      AUX(1:1)=' '
      NAUX=1
      IF(IUNIT(40).GT.0) THEN
         NAUX=16
         AUX(1:NAUX)=' AUXILIARY IFACE'
      END IF
      IF(CAUX(2).NE.' ') THEN
         NA1=NAUX+1
         NAUX=NA1+26
         AUX(NA1:NAUX)=' AUXILIARY '//CAUX(2)
      END IF
      IF(CAUX(3).NE.' ') THEN
         NA1=NAUX+1
         NAUX=NA1+26
         AUX(NA1:NAUX)=' AUXILIARY '//CAUX(3)
      END IF
10    CALL VALGET('CONST',0,0,ITYPE,CONST)
      IF(ITYPE.NE.0) CONST=0.
      IF(CONST.LE.0. .AND. ICALC.GT.0) THEN
         CALL PMXCNW(MESSFL,307,9,50,1,0,LINCNT)
         CALL STRCON
         GO TO 10
      END IF
C  Choose an appropriate format for writing CONST
      IF(CONST.LT.0.1) THEN
         WRITE(IFIL,'(5I10,1P,G10.3,2I10,2A)')
     1     MXSTRM,NSS,NTRIB,NDIV,ICALC,CONST,ITMPUN,ITMPU2,AUX(1:NAUX),
     2     '  MXSTRM,NSS,NTRIB,NDIV,ICALC,CONST,ISTCB1,ISTCB2'
      ELSE IF(CONST.LT.100.0) THEN
         WRITE(IFIL,'(5I10,F10.6,2I10,2A)')
     1     MXSTRM,NSS,NTRIB,NDIV,ICALC,CONST,ITMPUN,ITMPU2,AUX(1:NAUX),
     2     '  MXSTRM,NSS,NTRIB,NDIV,ICALC,CONST,ISTCB1,ISTCB2'
      ELSE IF(CONST.LT.1.E8) THEN
         WRITE(IFIL,'(5I10,F10.0,2I10,2A)')
     1     MXSTRM,NSS,NTRIB,NDIV,ICALC,CONST,ITMPUN,ITMPU2,AUX(1:NAUX),
     2     '  MXSTRM,NSS,NTRIB,NDIV,ICALC,CONST,ISTCB1,ISTCB2'
      ELSE
         WRITE(IFIL,'(5I10,1P,G10.3,2I10,2A)')
     1     MXSTRM,NSS,NTRIB,NDIV,ICALC,CONST,ITMPUN,ITMPU2,AUX(1:NAUX),
     2     '  MXSTRM,NSS,NTRIB,NDIV,ICALC,CONST,ISTCB1,ISTCB2'
      END IF
C
C  Write a list for each stress period
      DO 1000 KPER=1,NPER
      CALL IVLGET('STREAM',0,KPER,NAR,NSTREM)
      IF(NAR.GT.0) THEN
C
C  Data are defined -- write ITMP record
         CALL IVLGET('IRDFLG',0,KPER,ITYPE,IRDFLG)
         IF(ITYPE.NE.0) IRDFLG=0
         CALL IVLGET('IPTFLG',0,KPER,ITYPE,IPTFLG)
         IF(ITYPE.NE.0) IPTFLG=0
         WRITE(IFIL,'(3I10,A,I4)') NSTREM,IRDFLG,IPTFLG,
     1'  ITMP, IRDFLG, IPTFLG -- Stress Period',KPER
         IF(NSTREM.GT.0) THEN
C  If the list has values in it, write the various data sets
            LOC=IARRDA(2,NAR)
            LSTDIM=IARRDA(3,NAR)
            ISOLD=0
C
C  Start by writing the Main list
            DO 50 M=1,NSTREM
            IGROUP=(M-1)/MXLIST + 1
            L=IX(LOC+IGROUP-1) + (M-1 - (IGROUP-1)*MXLIST)*LSTDIM - 1
C  Get layer, row, column values
            K=X(L+1)
            I=X(L+2)
            J=X(L+3)
            IS=X(L+7)
            IF(IS.NE.ISOLD) THEN
               ISOLD=IS
               NR=0
            END IF
C  Count reach number within a segment
            NR=NR+1
            WRITE(RECORD,'(5I5,1P,G15.5,4F10.0)') K,I,J,IS,NR,X(L+8)
            NREC=40
            CALL UWRFLD(X(L+4),FIELD)
            N1=NREC+1
            NREC=NREC+10
            RECORD(N1:NREC)=FIELD
            CALL UWRFLD(X(L+5),FIELD)
            N1=NREC+1
            NREC=NREC+10
            RECORD(N1:NREC)=FIELD
            CALL UWRFLD(X(L+6),FIELD)
            N1=NREC+1
            NREC=NREC+10
            RECORD(N1:NREC)=FIELD
            CALL UWRFLD(X(L+11),FIELD)
            N1=NREC+1
            NREC=NREC+10
            RECORD(N1:NREC)=FIELD
C  Get IFACE if appropriate
            IF(IUNIT(40).GT.0) THEN
               IFACE=X(L+15)
               WRITE(FIELD,'(I10)') IFACE
               N1=NREC+1
               NREC=NREC+10
               RECORD(N1:NREC)=FIELD
            END IF
C  Get auxiliary parameters after IFACE
            DO 45 N=2,NCAUX
            IF(CAUX(N).NE.' ') THEN
            CALL UWRFLD(X(L+14+N),FIELD)
            N1=NREC+1
            NREC=NREC+10
            RECORD(N1:NREC)=FIELD
            END IF
45          CONTINUE
C  Write one record for main list
            WRITE(IFIL,'(A)') RECORD(1:NREC)
50          CONTINUE
C
C  Write data for calculating stage (WIDTH, SLOPE, and ROUGH)
            IF(ICALC.GT.0) THEN
               DO 200 II=1,NSTREM
               IGROUP=(II-1)/MXLIST + 1
               L=IX(LOC+IGROUP-1) + (II-1-(IGROUP-1)*MXLIST)*LSTDIM - 1
               NREC=0
               CALL UWRFLD(X(L+12),FIELD)
               N1=NREC+1
               NREC=NREC+10
               RECORD(N1:NREC)=FIELD
               CALL UWRFLD(X(L+13),FIELD)
               N1=NREC+1
               NREC=NREC+10
               RECORD(N1:NREC)=FIELD
               CALL UWRFLD(X(L+14),FIELD)
               N1=NREC+1
               NREC=NREC+10
               RECORD(N1:NREC)=FIELD
               WRITE(IFIL,'(A)') RECORD(1:NREC)
200            CONTINUE
            END IF
C
C  Write tributary data
            IF(NTRIB.GT.0) THEN
               DO 300 IS=1,NSS
               DO 250 N=1,NTRIB
               ITRIB(N)=0
250            CONTINUE
               NT=0
               ISOLD=0
               DO 290 N=1,NSTREM
               IGROUP=(N-1)/MXLIST + 1
               L=IX(LOC+IGROUP-1) + (N-1-(IGROUP-1)*MXLIST)*LSTDIM-1
               ISNEW=X(L+7)
               IF(ISNEW.NE.ISOLD) THEN
                  ISOLD=ISNEW
                  IT=X(L+9)
                  IF(IT.EQ.IS) THEN
                     NT=NT+1
                     IF(NT.LE.10) ITRIB(NT)=X(L+7)
                  END IF
               END IF
290            CONTINUE
               WRITE(IFIL,'(10I5)') (ITRIB(N),N=1,NTRIB)
300            CONTINUE
            END IF
C
C  Write Diversion data
            IF(NDIV.GT.0) THEN
               ISOLD=0
               DO 400 N=1,NSTREM
               IGROUP=(N-1)/MXLIST + 1
               L=IX(LOC+IGROUP-1) + (N-1-(IGROUP-1)*MXLIST)*LSTDIM-1
               ISNEW=X(L+7)
               IF(ISNEW.NE.ISOLD) THEN
                  ISOLD=ISNEW
                  ID=X(L+10)
                  WRITE(IFIL,'(I10)') ID
               END IF
400            CONTINUE
               IF(ISOLD.LT.NSS) THEN
                  DO 410 N=ISOLD+1,NSS
                  WRITE(IFIL,'(I10)') 0
410               CONTINUE
               END IF
            END IF
C
         END IF
C  Done writing data when NSTREM>0
      ELSE
C  Missing data
         WRITE(IFIL,'(I10,A,I4)') IMISS,
     1  '         0         0  ITMP, IRDFLG, IPTFLG -- Stress Period',
     2                KPER
      END IF
1000  CONTINUE
C
      RETURN
      END
      SUBROUTINE STRMAX(NSS,NTRIB,NDIV,ICALC)
C     ******************************************************************
C     Find NSS, NTRIB, and NDIV for STR data
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      DIMENSION IX(LENX)
      EQUIVALENCE (X,IX)
C
      NSS=0
      NTRIB=0
      NDIV=0
      ICALC=0
      DO 100 KPER=1,NPER
      CALL IVLGET('STREAM',0,KPER,NAR,NSTREM)
      IF(NAR.GE.0) THEN
C  Data are defined -- scan list
         LSTDIM=IARRDA(3,NAR)
         IF(NSTREM.GT.0) THEN
            IXL=IARRDA(2,NAR)
            ISOLD=0
            DO 50 M=1,NSTREM
            IGROUP=(M-1)/MXLIST + 1
            LOC=IX(IXL+IGROUP-1) + (M-1 - (IGROUP-1)*MXLIST)*LSTDIM -1
C  Turn on stage calculations if any width, slope, or roughness is not 0.
            IF(X(LOC+12).GT.0. .OR. X(LOC+13).GT.0. .OR.
     1                              X(LOC+14).GT.0.) ICALC=1
C  Check for diversions -- a single diversion turns this feature on
            ND=X(LOC+10)
            IF(ND.GT.0) NDIV=1
C  Count number of tributaries
            IS=X(LOC+7)
            IF(IS.NE.ISOLD) THEN
               ISOLD=IS
               NT=0
               ISOLD2=0
               DO 40 N=1,NSTREM
               IGROUP=(N-1)/MXLIST + 1
               LOC2=IX(IXL+IGROUP-1) + (N-1-(IGROUP-1)*MXLIST)*LSTDIM-1
               IS2=X(LOC2+7)
               IF(IS2.NE.ISOLD2) THEN
                  ISOLD2=IS2
                  IT=X(LOC2+9)
                  IF(IT.EQ.IS) NT=NT+1
               END IF
40             CONTINUE
               IF(NT.GT.NTRIB) NTRIB=NT
            END IF
C
50          CONTINUE
C  Set the maximum segment number
            NS=X(LOC+7)
            IF(NS.GT.NSS) NSS=NS
         END IF
      END IF
100   CONTINUE
C
      RETURN
      END
      SUBROUTINE STRCON
C     *****************************************************************
C     Define CONST and ISTCB2
C     *****************************************************************
      INCLUDE 'mfi.gbl'
      CHARACTER*78 CSTCB2
C     -----------------------------------------------------------------
C
C  Initialize screen
6     CALL Q1INIT(MESSFL,307,7)
C  Define initial values
      CALL VALGET('CONST',0,0,ITYPE,CONST)
      IF(ITYPE.NE.0) CONST=0.
      IF(CONST.GT.1.48582 .AND. CONST.LT.1.48602) THEN
         CONST=1.48592
         IOPT=1
      ELSE IF(CONST.GT.89.1542 .AND. CONST.LT.89.1562) THEN
         CONST=89.1552
         IOPT=2
      ELSE IF(CONST.GT.128373. .AND. CONST.LT.128393.) THEN
         CONST=128383.
         IOPT=3
      ELSE IF(CONST.GT.46891100. .AND. CONST.LT.46893100.) THEN
         CONST=46892100.
         IOPT=4
      ELSE IF(CONST.GT.0.999999 .AND. CONST.LT.1.00001) THEN
         CONST=1.0
         IOPT=5
      ELSE IF(CONST.GT.59.9999 .AND. CONST.LT.60.0001) THEN
         CONST=60.0
         IOPT=6
      ELSE IF(CONST.GT.86399. .AND. CONST.LT.86401.) THEN
         CONST=86400.
         IOPT=7
      ELSE IF(CONST.GT.31556600. .AND. CONST.LT.31558600.) THEN
         CONST=31557600.
         IOPT=8
      ELSE
         IOPT=9
      END IF
      CALL QSETOP(1,1,1,1,IOPT)
      CALL QSETR(1,CONST)
      CALL IVLGET('ISTCB2',0,0,ITYPE,ISTCB2)
      IF(ITYPE.NE.0) ISTCB2=0
      CSTCB2=' '
      IF(ISTCB2.GT.0) CSTCB2=FILNAM(ISTCB2)
      CALL QSETCT(1,78,78,CSTCB2)
C  Activate user input
      CALL Q1EDIT(IRET)
      IF(IRET.EQ.-1) GO TO 6
C  Retrieve responses
      CALL QGETR(1,CONST)
      CALL QGETOP(1,IOPT)
      IF(IOPT.EQ.1) THEN
         CONST=1.48592
      ELSE IF(IOPT.EQ.2) THEN
         CONST=89.1552
      ELSE IF(IOPT.EQ.3) THEN
         CONST=128383.
      ELSE IF(IOPT.EQ.4) THEN
         CONST=46892100.
      ELSE IF(IOPT.EQ.5) THEN
         CONST=1.0
      ELSE IF(IOPT.EQ.6) THEN
         CONST=60.
      ELSE IF(IOPT.EQ.7) THEN
         CONST=86400.
      ELSE IF(IOPT.EQ.8) THEN
         CONST=31557600.
      END IF
      CALL VALSAV('CONST',0,0,CONST)
      CALL QGETCT(1,78,78,CSTCB2)
      CALL USTLFT(CSTCB2,78)
      IF(IUCASE.NE.0) CALL USTRUC(CTSCB2,78)
      IF(CSTCB2.EQ.' ') THEN
         ISTCB2=0
      ELSE
         CALL FNMSV3(CSTCB2,IU,'DATA(BINARY)',IUNIT(18),0)
         IF(IU.LT.0) GO TO 6
         ISTCB2=IU
      END IF
      CALL IVLSAV('ISTCB2',0,0,ISTCB2)
C
      RETURN
      END
